// Toggles
//
// Used in conjunction with global variables to enable certain theme features.

// Vendor
@import "vendor/rfs";

// Deprecate
@import "mixins/deprecate";

// Helpers
@import "mixins/breakpoints";
@import "mixins/color-scheme";
@import "mixins/image";
@import "mixins/resize";
@import "mixins/visually-hidden";
@import "mixins/reset-text";
@import "mixins/text-truncate";

// Utilities
@import "mixins/utilities";

// Components
@import "mixins/alert";
@import "mixins/buttons";
@import "mixins/caret";
@import "mixins/pagination";
@import "mixins/lists";
@import "mixins/list-group";
@import "mixins/forms";
@import "mixins/table-variants";

// Skins
@import "mixins/border-radius";
@import "mixins/box-shadow";
@import "mixins/gradients";
@import "mixins/transition";

// Layout
@import "mixins/clearfix";
@import "mixins/container";
@import "mixins/grid";

@mixin gap($gap, $element: div, $direction: row, $type: "margin") {
	@if $direction == row {
		& {
			margin-left: -$gap/2;
			margin-right: -$gap/2;
		}
		@at-root #{$element} {
			@if $type == "margin" {
				margin-left: $gap/2;
				margin-right: $gap/2;
			}
			@if $type == "padding" {
				padding-left: $gap/2;
				padding-right: $gap/2;
			}
		}
	}
	@if $direction == column {
		& {
			margin-top: -$gap/2;
			margin-bottom: -$gap/2;
		}
		@at-root #{$element} {
			@if $type == "margin" {
				margin-top: $gap/2;
				margin-bottom: $gap/2;
			}
			@if $type == "padding" {
				padding-top: $gap/2;
				padding-bottom: $gap/2;
			}
		}
	}
}

@mixin has-scrollbar() {
	&::-webkit-scrollbar {
		-webkit-appearance: none;
		width: 3px;
		height: 3px;
	}

	&::-webkit-scrollbar-thumb {
		background-color: $primary;
	}
}

@mixin ratio($width, $height) {
	position: relative;
	&::before {
		display: block;
		content: "";
		width: 100%;
		padding-top: ($height / $width) * 100%;
	}
}

@mixin aspect-ratio($width, $height) {
	@include ratio($width, $height);
}

@mixin make-container-width($percent: 100%, $lower: "lg", $upper: "huge") {
	$breakpoint-names: map-keys($grid-breakpoints);
	$percent: $percent / 100%;
	$lower: index($breakpoint-names, $lower);
	$upper: index($breakpoint-names, $upper);

	@each $name, $width in $grid-breakpoints {
		$n: index($breakpoint-names, $name);

		@if $n >= $lower and $n <= $upper {
			@include media-breakpoint-up($name) {
				width: map-get($container-max-widths, $name) * $percent;
			}
		}
	}
}

@mixin quantity-selector() {
	display: flex;
	align-items: center;
	flex-direction: row;
	justify-content: flex-start;
}

@mixin quantity-selector-button() {
	border-radius: $border-radius;
	color: $body-color;
	font-family: $font-family-quantity-buttons;
	background: transparent;
	font-size: 15px;
	transition: $transition-base;
	width: 28px !important;
	height: 37px;
	line-height: 37px;

	&:active {
		background: #fafafb;
	}
}

@mixin quantity-selector-button-minus() {
	border: 1px solid $border-color;
	border-right: none;
}

@mixin quantity-selector-button-plus() {
	border: 1px solid $border-color;
	border-left: none;
}

@mixin quantity-selector-input() {
	border: none;
	border-top: 1px solid $border-color;
	border-bottom: 1px solid $border-color;
	color: $secondary;
	height: 2.3rem;
	width: 28px !important;
	font-weight: $font-weight-semibold;
	padding: 1px 2px;
	background: transparent;
	margin: 0;

	&:focus {
		border-color: $border-color;
		background: transparent;
	}
}
